package services;

import java.util.ArrayList;
import java.util.List;

import model.Kunde;
import services.io.KundenIOHandler;

public class KundenService {
    private List<Kunde> kunden = new ArrayList<Kunde>();

    public KundenService() {
        this.kunden = getAll(null);
    }

    public void create(Kunde kunde) {
        kunden.add(kunde);
    }

    public void update(int id, String name, String lastName) {
        Kunde kunde = new Kunde(-1, "", "");
        for (Kunde k : kunden)
            if (k.getId() == id)
                kunde = k;
        kunde.setName(name);
        kunde.setLastName(lastName);
    }

    public void delete(int id) {
        Kunde kunde = new Kunde(-1, "", "");
        for (Kunde k : kunden)
            if (k.getId() == id)
                kunde = k;
        kunden.remove(kunde);
    }

    public Kunde read(int id) {
        for (Kunde kunde : kunden) {
            if (kunde.getId() == id)
                return kunde;
        }
        return null;
    }

    public int getUnusedId() {
        int id = 0;
        for (Kunde k : kunden)
            if (k.getId() >= id)
                id = k.getId() + 1;
        return id;
    }

    public Kunde read(String name, String lastName) {
        for (Kunde kunde : kunden) {
            if (kunde.getName() == name && kunde.getLastName() == lastName)
                return kunde;
        }
        return null;
    }

    public Object[][] getTableData() {
        Object[][] data = new Object[kunden.size()][];
        int id = 0;
        for (Kunde kunde : kunden) {
            data[id] = new Object[] { kunde.getId(), kunde.getName(), kunde.getLastName(), "Location" };
            id += 1;
        }
        return data;
    }

    public List<Kunde> getAll(String fileName) {
        return KundenIOHandler.read(fileName);
    }

    public void saveAll(List<Kunde> kunden, String fileName) {
        KundenIOHandler.write(kunden, fileName);
    }

    public void saveAllFromInternData() {
        saveAll(kunden, null);
    }
}