package services.io;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

import model.Kunde;

public class KundenIOHandler {
    public static List<Kunde> read(String fileName) {
        if (fileName == null)
            fileName = "kunden.txt";
        List<Kunde> kunden = new ArrayList<Kunde>();
        try {
            BufferedReader reader = new BufferedReader(new FileReader(fileName));
            String line = null;
            while ((line = reader.readLine()) != null) {
                String[] val = line.split("#");
                kunden.add(new Kunde(Integer.parseInt(val[0]), val[1], val[2]));
            }
            reader.close();
            System.out.println(kunden);
            return kunden;
        } catch (IOException ex) {
            System.out.println("###ERROR### (IOException)");
        }
        return null;
    }

    public static void write(List<Kunde> kunden, String fileName) {
        if (fileName == null)
            fileName = "kunden.txt";
        try (PrintWriter writer = new PrintWriter(new FileWriter(fileName))) {
            for (Kunde kunde : kunden) {
                String line = Integer.toString(kunde.getId());
                line += "#" + kunde.getLastName() + "#" + kunde.getName();
                writer.println(line);
            }
        } catch (IOException ex) {
            System.out.println("###ERROR### (IOException)");
        }
    }
}