package services;

import model.Kunde;
import org.junit.jupiter.api.Test;

import java.io.IOException;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.time.format.FormatStyle;
import java.util.Locale;

import static org.junit.jupiter.api.Assertions.*;

class DatenhaltungTest {

    @Test
    void testeKundeLadenUndSpeichernDeutsch() throws IOException {
        DateTimeFormatter germanFormatter = DateTimeFormatter.ofLocalizedDate(FormatStyle.MEDIUM)
                .withLocale(Locale.GERMAN);
        Kunde kunde1 = new Kunde("Angela", "Merkel", LocalDate.parse("05.07.1958", germanFormatter));
        Datenhaltung.speichereKunde(kunde1, Locale.GERMAN);
        Kunde kunde1comp = Datenhaltung.ladeKunde(Locale.GERMAN);
        assertEquals(kunde1.getFirstName(), kunde1comp.getFirstName());
        assertEquals(kunde1.getName(), kunde1comp.getName());
        assertEquals(kunde1.getBirthday(), kunde1comp.getBirthday());
    }

    @Test
    void testeKundeLadenUndSpeichernEnglisch() throws IOException {
        DateTimeFormatter englishFormatter = DateTimeFormatter.ofLocalizedDate(FormatStyle.MEDIUM)
                .withLocale(Locale.ENGLISH);
        Kunde kunde2 = new Kunde("Theresa", "May", LocalDate.parse("Jun 30, 1969", englishFormatter));
        Datenhaltung.speichereKunde(kunde2, Locale.ENGLISH);
        Kunde kunde2comp = Datenhaltung.ladeKunde(Locale.ENGLISH);
        assertEquals(kunde2.getFirstName(), kunde2comp.getFirstName());
        assertEquals(kunde2.getName(), kunde2comp.getName());
        assertEquals(kunde2.getBirthday(), kunde2comp.getBirthday());
    }
}